CĿ
C     Name: Chol                                             12/12/03 01:30pm 
C                                                                             
C     Description: Solve linear equations matrix by Choleski (Kraut) method   
C                                                                             
C     Gregory Ivakhnenko (c)                                                  
C

      subroutine  Chol ( Kl, M,M1, MM1, SNor,B,C, CO )

	integer, intent(OUT)::  Kl
	integer, intent(IN)::   M, M1, MM1
	real(8), intent(IN)::   SNor ( MM1,MM1 )
      real(8), intent(INOUT)::B ( MM1,MM1 ), C( MM1,MM1 )
      real(8), intent(OUT)::  CO( MM1 )
      integer, automatic::	i, k

	Kl = 0
      forall( i= 2:M1 ) B( i,i:M ) = 0.		! Initialize triangle matrixes                            
	B( 1,:M ) = SNor( 1,:M )
      
	forall( i= 2:M )  C( i,i ) = 1.
      C( :M1,1 ) = SNor( :M1,1 ) / SNor( 1,1 )

	do i= 2,M								! Main time loop !
		forall( k= i:M )
     +		B( i,k ) = SNor( i,k ) - sum( B(:i,k ) * C( i,:i ))
      
          if( B( i,i ) == 0. ) then
			CO = 0.
			Kl = 1
              return
		endif

          forall( k= i+1:M1 )
     +C( k,i ) = ( SNor( k,i ) - sum( B(:i-1,i ) * C( k,:i-1 )))/ B(i,i)

	end do

	CO( M ) = C( M1,M )						 
      do i= M,2,-1							! Estimate coefficients
		CO( i-1 ) = C( M1,i-1 ) - sum( C( i:M,i-1) * CO( i:M ))
      end do

	end subroutine Chol
