CĿ
C     Name: CReg                                             06.05.97 15:47pm 
C                                                                             
C     Description: Calculation of regularity criterion.                       
C                                                                             
C     Gregory Ivakhnenko (c)                                                  
C

      subroutine  CReg ( Kl,LT,LCh, S, X,SNor,SNorm,B,C,CO,In,IAn)
      real        X   ( ML,N )
      real*8      SNor( ML1,ML1 ), C ( ML1,ML1 ), B( ML1,ML1 ),
     +            CO  ( ML1 ),     SNorm( ML1,ML1 ), S
      integer     IAn ( ML11 )
      integer*2   In  ( N )
      common /LSize/  ML,ML0,ML1,ML11,N,LF, MV,MV1,MV2, Qmax
      automatic

	! Calculate model for training subsample A
	forall( I=1:MV )
		SNorm( I+1,  1 ) = SNor( IAn( I )+1,   1 ) ! form first row of XtX
		SNorm( MV2,I+1 ) = SNor( ML1, Ian( I )+1 ) ! form XtY column
	end forall
	
	forall( I=1:MV )
		forall( J=1:I )
			SNorm( I+1,J+1 ) = SNor( IAn( I )+1,IAn( J )+1 ) ! form column J
		end forall
		SNorm( 1:I,I+1 ) = SNorm( I+1,1:I )					 ! copy to row I
	end forall

	call Chol ( Kl, MV1,MV2, ML1, SNorm,B,C, CO )	! estimate coefficients
      if( Kl .ne. 0 ) return         

	! Calculate criterion for test subsample B
	S = 0.
      do I= LT+1,N
		S = S + ( X( ML0,In(I)) - 
     +		CO( 1 ) - sum( X( IAn(1:MV),In(I)) * CO(2:MV1)) )**2 ! Calculate model value
	end do
	
	S = S / LCh
	return
      end