C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C     Name: MODEL                                            02-23-96 10:50am 
C                                                                             
C     Description: Main submodule of COMBI algoritm.                          
C                                                                             
C     Gregory Ivakhnenko (c)                                                  
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      subroutine MODEL ( io,M0,M1,MY,NT,X,XT,AA,SNor,SNorB,SNorm,SNorm2,
     +                  B,C,CO,CR, VN,VNy,ForVal, RMin,RMax, Im,In,IAnL,
     +                  IAn,SelAn,IMq,IMv )
      real
     +			X ( ML, N ),     XT ( M0,NT ),  AA( ML1,N ),
     +			RMin ( ML ),	 RMax( ML )
      real*8      SNor( ML1,ML1 ), SNorm( ML1,ML1 ),
     +            SNorB( ML1,ML1 ),SNorm2( ML1,ML1 ), 	 
     +			C( ML1,ML1 ),	 B( ML1,ML1 ),
     +			VN ( N ),        VNy ( N ),
     +            CO  ( ML1 ),     CR  ( LF ),    ForVal( 2,NT )
      integer     IAn ( ML11 ),    IMv( ML11 ),
     +            SelAn( LF,ML11 ),IAnL( ML11 )
      integer*2   Im  ( 600 ),     In ( N ),		IMq ( ML11 )     

      logical*1      KL1, KL2, Klayer
      integer        Kl, nKl, nSelModels, maxIdx
      real*8         S,SS, minCrLayer, CR1,CR2, CRmin

      common /LDat/   JPr
      common /LMai1/  JRes,  JFile, JGraph, JNorm, JProt, LFor,
     +                LAn,   LTest, LSel
      common /LMai2/  JFun,  JS,    JRegul, ISe, ICr, JDiv
      common /LSize/  ML, ML0, ML1, ML11, N, LF, MV,MV1,MV2, Qmax
C**********************************************************************
C           Choice of criteria type
C**********************************************************************
      if( ICr .eq. 0 .or. ICr .eq. 2 ) then     ! Regularity or correlation criterion

		if( JDiv == 1 ) then
			call Deviat ( LCh, ML,ML11,ML1, N, X,CO, Vn,In )    ! Divide points		
		else 
			call DivRandom ( N, Vn,In )
			Lch = 0.37 * N			    	  ! 37% of points in test sample !
		endif
		LT  = N - LCh                         ! Set training subsample size

!     elseif( ICr .eq. 2 ) then                 ! Cross-validation criterion
!         LT  = N
!         LCh = 1

      elseif( ICr .eq. 1 ) then                 ! Balance of subsamplings criterion
		LT  = N/2
		LCh = N - LT

      endif

      if( JPr .ge. 1 ) then
         write (*,444)  LT, LCh, LTest
         if( JFile .ne. 0 )  write (io,444)  LT, LCh, LTest
      endif
C**********************************************************************
C           Sorting of data arrays with different Y vectors
C**********************************************************************
      do 100 LL= 1,MY								! MY cycle
		write (*,111)
          if( MY .gt. 1 )  write (*,333) -Im( ML0 )      ! Write Y number
          write (*,665)

		if( JFile .ne. 0 ) then           ! Write Y no. to file
			write (io,111)
			if( MY .gt. 1 ) write (io,333) -Im( ML0 )
		endif

		if( ICr .eq. 2 ) then                  ! For correlation calculate vector VNy
	      S = 0.                              
	      J = 0
	      do 30 I= LT+1,N
	         J = J + 1
               S = S + X( ML0,In( I ))
30             VNy( J ) = X( ML0,In( I ))
            S = S / LCh                         ! Calculation of average

            do 110 I= 1,LCh
110            VNy( I ) = VNy( I ) - S          ! tmp vector construction
		endif
!------------- Calculate XtX, XtY matrixes -----------------------------
		AA( 1,: ) = 1.                        ! Initialize first column of AA array
		if( ICr .eq. 1 ) then				  ! For balance criterion
			L = 0
			do 210 I= 1,N,2
				L = L + 1
				AA( ML1,L ) = X( ML0,In( I ))  
					do 210 J= 1,ML11            
210					AA( J+1,L ) = X( J,In( I ))

			do 220 K= 1,ML                         ! ନ஢ ᨢ ଠ
			   do 220 L= K,ML1                     ! ࠢ
			   S = 0.
					do 230 I= 1,LT
230					S = S + AA( K,I ) * AA( L,I )
			   SNor( L,K ) = S
220			   SNor( K,L ) = S

			L = 0
			do 240 I= 2,N,2
				L = L + 1
				AA( ML1,L ) = X( ML0,In( I ))  
					do 240 J= 1,ML11            
240					AA( J+1,L ) = X( J,In( I ))

			do 250 K= 1,ML                         ! ନ஢ ᨢ ଠ
			   do 250 L= K,ML1                     ! ࠢ
			   S = 0.
					do 280 I= 1,LT
280					S = S + AA( K,I ) * AA( L,I )
			   SNorB( L,K ) = S
250    		   SNorB( K,L ) = S

			SNorm2( 1,1 ) = SNorB( 1,1 )
		else

			do 60 I= 1,LT						  ! for all another criteria
			   AA( ML1,I ) = X( ML0,In( I ))      !  write function at right col.
			   do 60 J= 1,ML11                    ! Creating AA array
60               AA( J+1,I ) = X( J,In( I ))        !  by current variables ansamble

			do 80 K= 1,ML                         ! ନ஢ ᨢ ଠ
			   do 80 L= K,ML1                     ! ࠢ
			   S = 0.
					do 70 I= 1,LT
70					S = S + AA( K,I ) * AA( L,I )
			   SNor( L,K ) = S
80			   SNor( K,L ) = S
		endif

		SNorm( 1,1 ) = SNor( 1,1 )

		MV    = 1
		KL1   = .true.
		nKl   = 0
		CRmin = Qmax
		CR1   = Qmax                               ! CRmin for previous M
		CR2   = Qmax                               ! CRmin for second M before
		ISq   = ISe                                ! Restore no. of selection layer
		nSelModels = 0
		maxIdx = 1

		CR = Qmax								  ! Initialize CR vector for all ensembles
		SelAn = 0
C**********************************************************************
C           Ensembles sorting-out cycle
C**********************************************************************
      do 200 while (KL1)                        ! Sorting of number of var. in ensembles
          MV1 = MV + 1
          MV2 = MV + 2
          Klayer = .false.                       ! Key - min founded

	    IAn = 0
	    IMv = 0
          if( MV .gt. ISq .and. LSel .ne. 0 ) then
            do 40 I= 1,MV
               IAn( I ) = IMq( I )
40             IMv( I ) = I
          else
            do 50 I= 1,MV
50          IAn( I ) = I                        ! Create initial ensemble
          endif

		SNorm ( MV2,1 ) = SNor ( ML1,1 )
		SNorm2( MV2,1 ) = SNorB( ML1,1 )

	    minCrLayer = Qmax
          KL2 = .true.
! ++++++++++++++++++++++++  MAIN COMPUTATION LOOP  +++++++++++++++++++
		do 300 while( KL2 )                    ! All ensembles for current M loop
            if    ( ICr .eq. 0 )  then          ! Regularity criterion
               call CReg ( Kl,LT,LCh,S, X,SNor,SNorm,B,C,CO,In,IAn )

!            elseif( ICr .eq. 2 )  then          ! Cross-validation criterion
!			 write( *,* ) 'CV criterion cannot be used !!!'
!			 stop

            elseif( ICr .eq. 1 )  then          ! Balance criterion
               call Balan2( Kl,S, X, SNor,SNorB,SNorm,SNorm2,
     +						B,C, CO, IAn)

            elseif( ICr .eq. 2 )  then          ! Correlation criterion
               call Corel(Kl, LT,LCh,S, X, AA,SNor,SNorm,B,C, CO,
     +						VN,VNy, In,IAn)
            endif

            if( JPr .ge. 2 ) then
               write(*,667) S,( Im( IAn( J )),J= 1,MV )	! Write ensemble
               if( JFile.ne.0 ) write(io,667) S,(Im( IAn(J)), J=1,MV )
            endif

		  nKl = nKl + Kl
		  if( Kl .ne. 0 )  goto 301           ! Not solved - dont write CR do next ensemble
											  ! Save LAn best ensembles & crit
      	  call SelectModels( nSelModels, maxIdx, S, CR, IAn, SelAn )

		  if( minCrLayer > S ) then
			 minCrLayer = S ! Save minimal criterion value at current layer
			 IAnL = IAn
	      endif
                                                
 		  Klayer = .true.					  ! Key - coef and min founded

301         if( MV .gt. ISq .and. LSel .ne. 0 ) then
                call Full_Cut ( KL2, MV,Lsel,ML11, IMv ) ! Generate new ensemble
                  do 10 I= 1,MV
10                IAn( I ) = IMq( IMv( I ))     ! IMv remain the same
            else
               call Full_Cut ( KL2, MV,ML11,ML11, IAn )  ! Generate new ensemble
            endif                                        ! KL2=T Next MV - all ensembles used

300      continue                               ! End ensembles IMq( MV ) cycle
! ++++++++++++++++++++++++  END of MAIN COMPUTATION LOOP  ++++++++++++

         if( .not. Klayer ) then                ! No solved systems
            write (*,556) MV
            if( JFile .ne. 0 ) write (io,556) MV
            if( MV .ge. ML11 ) then
C               exit                             ! Exit 200 loop
               goto 201

            elseif( MV .ge. LSel .and. LSel .ne. 0 ) then
	         goto 201

            elseif( MV .eq. ISq .and. LSel .ne. 0 ) then
               ISq = ISq +1                     ! Try to make selection at next layer
               write (*,222)
            endif
!            write (*,*)
            goto 200
         endif
C**********************************************************************
C           Range variables and select most effective at ISq layer
C**********************************************************************
         if( MV .eq. ISq .and. LSel .ne. 0 ) then  
            if( LSel .lt. ISq+1 ) LSel = ISq+1     ! Change Lsel if it too small
                                                   ! At ISq layer LSel variables to IMs
		  IMq = 0
		  IMv = 0
	 	  call RaPIVe ( ML11, LF,ML11, CR,IMq )	! found ML11 mins in CR and write them into IMs
									! the first ML11 best models will be taken into account
            do J= 1,ML11              ! count occurance of vars in this models and save in IMv
	        do K= 1,ML11
	            do I= 1,ML11 
	                if( SelAn( IMq( J ),I ) == K ) IMv(K)=IMv(K) + 1 
	            enddo
	        enddo
            enddo
		
		  L = count( IMv /= 0, dim=1 )

		  do J= 1,ML11	
			I = maxloc( IMv, dim=1 )			! Found vars with max occurance
			IMq( J ) = I
			IMv( I ) = -1
		  enddo

            write (*,111)
            write (*,888)          ! Write ranged variables
            write (*,999) ( Im(IMq( I )), I=1,L )
            if( JFile .ne. 0 ) then
               write (io,111)
               write (io,888)
               write (io,999) ( Im(IMq( I )), I=1,L )
            endif

		  call RaVeI2 ( LSel,ML11, IMq )

            if( LSel .ge. ML11  .or.  MV .ge. ML11-3 ) then
               LSel = 0
               write (*,898)          ! Selection disabled LSel >= ML
            else
               ML11 = LSel            ! Reduce no. of input vars to LSel
            endif
            
            write (*,889) LSel
            write (*,111)

            if( JFile .ne. 0 ) then
               write (io,889) LSel
               write (io,111)
            endif
         endif                                ! and save new var no. in IMs
C**********************************************************************
C            Output of minimal criterion
C**********************************************************************
		if( CRmin > minCrLayer ) then
			CRmin = minCrLayer				! Save minimal criterion value

			K = minloc( Cr, dim=1 )         ! Found position of global CRmin
	   	    IAn(:) = SelAn( K,: )			! Get ansamble
	        L = count( IAn /= 0, dim=1 )    ! Count variables

             if( JFile  .ne. 0) 
     +       write (io,668) MV, CR( K ),( Im( IAn( i )),i= 1,L )
             write (*,668)  MV, CR( K ),( Im( IAn( i )),i= 1,L )
!             write (*,*)
         else
		   L = count( IAnL /= 0, dim=1 )      ! Count variables
             if( JFile  .ne. 0 ) 
     +	   write (io,669) MV,minCrLayer,( Im( IAnL( i )),i= 1,L )
             write (*,669)  MV,minCrLayer,( Im( IAnL( i )),i= 1,L )
!             write (*,*)
         endif

C**********************************************************************
C           Cancel procedure if criterion value is raising up
C**********************************************************************
140      if( MV .gt. ISq .and. LSel .ne. 0 ) then 
             if( MV .ge. LSel )  exit           
         elseif( MV .ge. ML11 ) then
             exit
         endif

         if( JS .ne. 0 )  then
            if((minCrLayer-CR1) > 1.E-5 .and. (minCrLayer-CR2) > 1.E-5 
     +			.and. CR1 .le. CR2 )  then  
               if( JPr .ge. 1 )  write (*, 555) CR2, minCrLayer
               if( JFile .ne. 0) write (io,555) CR2, minCrLayer
               KL1 = .false.
               exit                             ! Exit when criteria value raising
            endif
            CR2 = CR1
            CR1 = minCrLayer
         endif

200      MV = MV + 1                            ! End MV cycle
C**********************************************************************
C          Regularization
C**********************************************************************
201   call Regul( io, M0,NT, X,XT,AA,SNor,C,B,CO,CR,
     +            nSelModels,RMin,RMax, VN,VNy,ForVal, Im,In,SelAn,IAn)

C**********************************************************************
C           New function vector Y forming
C**********************************************************************
      if( MY .gt. 1 ) then
         if( LL .ne. MY .and. JPr .ge. 1 ) then
             write (*,66)                        ! Pause after results
             pause
         endif

         do 260 I= 1,N                          ! Form new X array with last Y column
            S = X ( M1,I )
            do 270 J= M1,ML-1
270            X ( J, I ) = X ( J+1,I )
260            X ( ML,I ) = S

         if( JNorm .ne. 0 ) then                ! If normilizing
            S  = RMax( M1 )                     ! change max & min vectors
            SS = RMin( M1 )                     ! according to Y columns moving
            do 290 J= M1,ML-1
               RMax( J ) = RMax( J+1 )
290            RMin( J ) = RMin( J+1 )
            RMax( ML ) = S
            RMin( ML ) = SS
         endif

         I = Im( M1 )                           ! change function columns numbers
            do 160 J= M1,ML-1
160         Im( J ) = Im( J+1 )
         Im( ML ) = I
      endif
      if( JFile.ne.0 .and. JRes.ge.1 .and. nKl.ne.0 ) write (io,44) nKl

100   continue                                  ! End cycle LL=MY
C**********************************************************************

      return
111   format (//,78 ('*'),/)
222   format (  10X, '*  Selection of variables is not done ',
     +               'at this layer *')
333   format (  10X, '*  Current  Y function  column  no.',I3,'  *', /)
33    format (  10X, '*  To break off press  Scroll Lock  key *', /)
44    format (/, 7X, '-  LSE method failed', I7,' times -')
444   format (/,10X, 'Number of points in the training subsample   -',
     +     I3,/,10X, 'Number of points in the test subsample       -',
     +     I3,/,10X, 'Number of points in the validation subsample -',
     +     I3)
555   format (/, 1X,
     +       '* Procedure canceled - criteria values are growing up: ',
     +          E9.3,' < ', E9.3,' *',/)
556   format (/,5X, '*  Layer',I3,
     +  ' was skiped, because all matrixes were ill-conditioned *')
665   format (   1X  '----------- Criterion value --- ',
     +               'Ensemble of variables ------------------------',/)
668   format (  'L', I3,' - Local min=', E10.3,
     +         ' - Model: ', 600I5 )
669   format (  'L', I3,' -       Min=', E10.3,
     +         ' - Model: ', 600I5 )
667   format (   1X, '   Cr =', E10.4,' -- ', 600I5 )
66    format (/,10X, '*  Press Enter to continue  *',/ )
777   format (/10X,'* ABNORMAL TERMINATION! RESULTS ARE INCOMPLETE *',/)
888   format (  9X,  'Variables are ranged in such order:')
889   format (//,9X, 'The first',I3,
     +               ' variables will be used at next layers')
898   format (/,9X,'* Selection disabled because it is not effective:',
     +               ' M > ML-3 or LSel >= ML  *',//,78('*'),/)
999   format(   9X,  67(''),/,7X, 600I5,/)
      end
