CĿ
C     Name: Res_Out                                          30.06.97 19:35pm 
C                                                                             
C     Description: Output of the results                                      
C                                                                             
C     Gregory Ivakhnenko  (c)                                                 
C

      subroutine  Res_Out (io, Var,SR, K,KK, M0,NT, XT, 
     +					 CO,CR, RMax,RMin, VN,VNy, ForVal, Im, IAn )

      real        XT  ( M0,NT ), RMin ( ML ),   RMax ( ML )
      real*8      CO  ( ML1 ),   CR ( LF ), ForVal( 2,NT ), 
     +			VN ( N ),      VNy ( N )
      integer     IAn ( ML11 ),  II, K
      integer*2   Im  ( 600 ),   KK

      real*8          S, SS, SR, CR1,CR2,CR3, Var, Rel
	integer::		I,J,L,LL, N,nVars

      common /LDat/   JPr
      common /LMai1/  JRes,    JFile,   JGraph,   JNorm,  JProt,  LFor,
     +                LAn,     LTest,   LSel
      common /LSize/  ML, ML0, ML1, ML11, N, LF,  MV,MV1,MV2, Qmax

	nVars = count( IAn /= 0, dim=1 )
C**********************************************************************
C           Calculate forecasts
C**********************************************************************
      SS  = 0.
      CR3 = 0.

      if( LFor .ne. 0 )  then                ! Calculate forecast
		LL = 0
	    do 90 II = 1,NT                    ! All test points
			L = 0
              S = CO( 1 )
              do 130 I= 1,nVars
				J = Im( IAn( I ))         
				if( J < 0 ) J = -J			  ! Is function(var) is in ansamble?
			    J  = J - 1					  ! delayed-1 !
                  JJ = J / 100                  ! Receive var no.
                  J  = J - JJ*100               ! Receive var argument no.
                  J  = II - J					  ! make shift
                  if( J > 0 ) then			  ! if delay inside subsample
					S = S + XT( JJ,J ) * CO( I+1 )	! calc forecast
				else 
					L = 1					  ! cannot calculate output value
					exit					  ! because delayed value is out of XT sample
130			endif
!130				if( JGraph /= 0 ) S = S + Co1 + (N-NT+II) * Co2

		  if( L == 0 ) then				  
!				S = S + ( XT( -Im( ML ),II ) - S )**2

			! Re_normilize data arrays
			if( JNorm .ne. 0 ) then
				call ReNorm ( ForVal( 1,II ),S,ML0, ML, RMax,RMin )
      			if( II .le. LTest ) 
     +			call ReNorm ( ForVal( 2,II ),XT(-Im(ML),II+1),-Im(ML),
     +						  ML,RMax,RMin )
			else
				ForVal( 1,II ) = S						! Save prediction value
				if( II .le. LTest ) ForVal(2,II) = XT(-Im( ML ),II+1)
			endif
                                
              if( II .le. LTest ) then
				CR3 = CR3 +     ( ForVal( 1,II ) - ForVal( 2,II ))**2	! Calculate MSE
				SS  = SS  + abs(( ForVal( 1,II ) - ForVal( 2,II ))/ 
     +    					   ForVal( 2,II )) * 100	! Calculate MAPE
				LL = LL + 1								! count calculated points
              endif										! because can be several delays 
		
		  endif
90		continue

          if( LL .ne. 0 ) then
			CR1 = SS / LL						! Save average MSE
              CR2 = CR3/ LL
		else
			CR1 = 0.
              CR2 = 0.
		endif
C-----------------------------------------------------------------------------
C           Calculate model values for validation subsample (without prediction)
C-----------------------------------------------------------------------------
      elseif( LTest .ne. 0 ) then
		do 180 II = 1,NT
			S = CO( 1 )

			do 190 I= 1,nVars
				JJ = Im( IAn( I ))
                  if( JJ .lt. 0 )  JJ = -JJ              ! Convert Y to column number
190               S = S + XT( JJ,II ) * CO( I+1 )
!190				if( JGraph /= 0 ) S = S + Co1 + (N-NT+II) * Co2

			if( JNorm .ne. 0 ) then
				call ReNorm ( ForVal( 1,II ),S,ML0, ML, RMax,RMin )
      			call ReNorm ( ForVal( 2,II ),XT(ML0,II),ML0, 
     +						  ML,RMax,RMin )
			else
				ForVal( 1,II ) = S						! Save dev.value
!				ForVal( 2,II ) = XT( -Im( ML ), II )
				ForVal( 2,II ) = XT( ML0, II )
			endif
                                
              CR3 = CR3 +     ( ForVal( 1,II ) - ForVal( 2,II ))**2	! Calculate MSE
180           SS  = SS  + abs(( ForVal( 1,II ) - ForVal( 2,II ))/ 
     +						  ForVal( 2,II )) * 100	! Calculate deviation
		CR1 = SS / NT
          CR2 = CR3/ NT
      endif
C-----------------------------------------------------------------------------
C           Calculate correlation
C-----------------------------------------------------------------------------
      S = 0.
         do 260 I= 1,N
260      S = S + VN( I )
      Rel = S / N                                 ! Calculation of model average

      S  = 0.
      SS = 0.
      CR3 = 0.
      do 280 I= 1,N
         S1 = VNy( I )  - Sr
         S2 = VN ( I )  - Rel

            CR3  = CR3  + S1*S2               ! Covariation
            S =  S  + S1**2
280         SS = SS + S2**2

      if( S*SS .eq. 0.) then
		S1 = 0.
          S2 = 0.
      else
          S1 = CR3 / sqrt( S*SS )          ! Corelation coefficient
          S2 = S1*S1                       ! R**2
      endif
C-----------------------------------------------------------------------------
C           Calculate values of deviations
C-----------------------------------------------------------------------------
      S   = 0.
      SS  = 0.
      Rel = 0.
      do 80 I= 1,N
		CR3 = VNy( I ) - VN( I )                ! Calculate deviation
!            if( abs( CR3 ) .ge. 1.E-14 ) then         !?  -> -7?
		if( VNy( I ) .ne. 0 ) Rel = Rel + abs( CR3 / VNy( I )) !!!!!!!  Relative deviation sum
          S   = S   + abs( CR3 )					! Absolute deviation sum
80        SS  = SS  + CR3**2						! Mean square deviation sum

!      CR3 = (Sre - SS) / Sre                     ! Q**2
      SS  = sqrt(SS / N)                          ! Mean square error (MSE)
      S   = S / N                                 ! Absolute average
      Rel = (Rel / N) * 100                       ! Relative deviation in %

	if( JNorm .ne. 0 ) then
		do I=1,N								! renorm calculated output
			call ReNorm ( VN(I),VN(I),ML0, ML, RMax,RMin )
		enddo
	endif
C-----------------------------------------------------------------------------
C           Write to file
C-----------------------------------------------------------------------------
      if( JFile .ne. 0 )  then                     ! Write to file
            write (io,999)                            ! ~
            if(( Var .lt. 0.00001 ) .or. Var .gt. 999. ) then
               write (io,993)  CR( KK ), K, KK    ! Write variation value
            else
               write (io,992)  CR( KK ), K, KK
            endif
            write (io,334)  Var                    ! Criterion, model selected
            write (io,889)  SS                     ! MSE
            write (io,443) S                       ! Absolute deviation
            write (io,445) S1                      ! Correlation
		  if( JRes .ne. 0 ) then
               write (io,446) S2                   ! R**2 (Correlation**2)
!               write (io,447) CR3                  ! Q**2 ((y-ysr)^2-mse)/(y-ysr)^2
            endif
            write (io,555) Rel                     ! Relative deviation
            write (io,33)  ( Im( IAn( J )), J= 1,nVars )

            write (io,111)
            if( abs( CO( 1 )) .gt. 0.000001 .and.
     +          abs( CO( 1 )) .lt. 10000.)   then
               write (io,220)  CO( 1 )
            else
               write (io,221)  CO( 1 )
            endif

            do 150 I= 1,nVars
               if( Im( IAn( I )) .gt. 0 ) then
                  if( abs( CO( I+1 )) .gt. 0.000001 .and.
     +                abs( CO( I+1 )) .lt. 10000.)    then
                     if( LFor .ne. 0 ) then
                        write (io,222) I, CO( I+1 ), Im( IAn( I ))    ! X101
                     else
                        write (io,223) I, CO( I+1 ), Im( IAn( I ))    ! X 1
                     endif
                  else
                     if( LFor .ne. 0 ) then
                        write (io,224) I, CO( I+1 ), Im( IAn( I ))    ! X101 E
                     else
                        write (io,225) I, CO( I+1 ), Im( IAn( I ))    ! X 1  E
                     endif
                  endif
               else
                  if( abs( CO( I+1 )) .gt. 0.000001 .and.
     +                abs( CO( I+1 )) .lt. 10000.)    then
                     if( LFor .ne. 0 ) then
                        write (io,226) I, CO( I+1 ),-Im( IAn( I ))    ! Y101
                     else
                        write (io,227) I, CO( I+1 ),-Im( IAn( I ))    ! Y 1
                     endif
                  else
                     if( LFor .ne. 0 ) then
                        write (io,228) I, CO( I+1 ),-Im( IAn( I ))    ! Y101 E
                     else
                        write (io,229) I, CO( I+1 ),-Im( IAn( I ))    ! Y 1  E
                     endif
                  endif
150            endif
            write (io,119)

            if( LFor .ne. 0 ) then
			 if( LTest .ne. 0 ) write (io,77) CR1,CR2	    ! Predictions deviation
               write (io,44)

               do 140 I= 1,NT                                 ! Write predictions
                  if( I .gt. LTest ) then
                     write (io,56) N+I+LFor-1, ForVal( 1,I )  ! No real Y value
                  else
                     write (io,55) N+I+LFor-1, ForVal( 1,I ),
     +                            ForVal( 2,I ),
     +                            ForVal( 2,I ) - ForVal( 1,I )
140               endif
               write (io,66)
            elseif( LTest .ne. 0 ) then
               write (io,118) CR1,CR2              ! Validation set deviations
               write (io,117)
               do 230 I= 1,NT
230            write (io,55) N+I, ForVal( 1,I ), ForVal( 2,I ),
     +                       ForVal( 2,I ) - ForVal( 1,I )
               write (io,66)
            endif

            if( JRes .ne. 0 ) then
!			 if( JGraph /= 0 ) ! then						! if needed to substract trend
!     +			VN(:) = VN(:) - CO( 1 ) - I * CO( 2 )
               write (io,667) ( VN ( J ), J= 1,N )   ! Calculated values
            endif
            write (io,*)
         endif
C-----------------------------------------------------------------------------
C           Write to screen
C-----------------------------------------------------------------------------
            write (*,999)
            if( Var .lt. 0.00001 .or. Var .gt. 999. ) then
               write (*,993)  CR( KK ), K, KK     ! Variation0
            else
               write (*,992)  CR( KK ), K, KK
            endif
            if( CR( KK ) .lt. 0.0001 .or.    !!!
     +          CR( KK ) .gt. 99999.) then
               write (*,334)  Var       ! Criterion in E format
            else
               write (*,333)  Var
            endif
            if( JPR  .gt. 0 ) write (*,888) SS        ! Mean square deviation
            if( JRes .ne. 0 ) then
               write (*,444)  S                      ! Absolute deviation
               write (*,445) S1                      ! Correlation
!               write (*,446) S2                      ! R**2 (Correlation**2)
!               write (*,447) CR3                     ! Q**2 ((y-ysr)2-mse)/(y-ysr)2
            endif
            write (*,555)  Rel                        ! Relative deviation
            write (*, 33)  ( Im( IAn( J )), J= 1,nVars ) ! Ansamble

            if( JPr .ge. 2 .or. JFile .eq. 0 )  then
               write (*,111)
               write (*,112) CO( 1 )
               do 170 I= 1,nVars
                  if( Im( IAn( I )) .gt. 0 ) then
                     if( LFor .ne. 0 ) then
                        write (*,113) I, CO( I+1 ), Im( IAn( I ))    ! X101
                     else
                        write (*,114) I, CO( I+1 ), Im( IAn( I ))    ! X 1
                     endif
                  else
                     if( LFor .ne. 0 ) then
                        write (*,115) I, CO( I+1 ),-Im( IAn( I ))    ! Y101
                     else
                        write (*,116) I, CO( I+1 ),-Im( IAn( I ))    ! Y 1
                     endif
170               endif
               write (*,119)

               if( LFor .ne. 0 ) then
                  if( LTest .ne. 0 ) write (*,77) CR1,CR2 ! Predictions deviation
                  write (*,44)
                  do 160 I= 1,NT                          ! Write predictions
                     if( I .gt. LTest ) then
                        write (*,56) N+I+LFor-1, ForVal( 1,I )       ! No real Y value
                     else
                        write (*,55) N+I+LFor-1, ForVal( 1,I ),
     +                               ForVal( 2,I ),
     +                               ForVal( 2,I ) - ForVal( 1,I )
160                  endif
                  write (*,66)
               elseif( LTest .ne. 0 ) then
                  write (*,118) CR1,CR2                   ! Validation set deviations
                  write (*,117)
                  do 210 I= 1,NT
210               write (*,55) N+I, ForVal( 1,I ), ForVal( 2,I ),
     +                         ForVal( 2,I ) - ForVal( 1,I )
                  write (*,66)
               endif
            endif
            write (*,*)
      return

667   format (/,1X,'Calculated values of output on train and test '
     +			'subsamples (not normilized):',/,10000( F16.10, 3X ))
999   format ( 79 ('~'))
992   format (  3X, 'Main criterion            =', F12.9,
     +         18X, 'Model',I2, 3X,'(',I2,')')
333   format (  3X, 'Additional criterion      =', F12.9 )
888   format (  3X, 'Mean square   dev. (MSE)  =', F12.9 )
444   format (  3X, 'Mean absolute dev. (MAE)  =', F12.9 )
445   format (  3X, 'Correlation coefficient   =', F12.9 )
446   format (  3X, 'R^2                       =', F12.9 )
!447   format (  3X, 'Q**2                      =', F12.9 )
555   format (  3X, 'Mean relative dev. (MAPE) =', F9.3,' %' )
993   format (  3X, 'Main criterion            =', E15.8,
     +         15X, 'Model',I2, 3X,'(',I3,')')
334   format (  3X, 'Additional criterion      =', E15.8 )
889   format (  3X, 'Mean square   dev. (MSE)  =', E15.8 )
443   format (  3X, 'Mean absolute dev. (MAE)  =', E15.8 )
33    format (  3X, 'Ensemble of variables     : ', 600I5 )
!11    format (/,5X, 'Predicted value of output  = ', E15.8 )
44    format (/,5X, 'Predicted values of output (not normilized):',/,
     +         3X,'ͻ',
     +       /,3X,' No.   Prediction   Real value  Abs.deviation ',
     +       /,3X,'Ķ')
117   format(/,5X,'Model values calculated on validation ',
     +            'subsample (not normilized):',/,
     +         3X,'ͻ',
     +       /,3X,' No.   Calculated   Real value  Abs.deviation ',
     +       /,3X,'Ķ')
56    format(3X,' ',I3,'  ',E11.5, '                       ')
55    format(  3X,' ',I3,'  ',E11.5,'  ',E11.5, '   ', E11.5, '  ')
66    format(3X,'ͼ',/)
77    format(//,5X, 'Prediction errors on validation sample:'
     +       ,/,'     MAPE =',F7.2,' %',4X,'MSE =',E10.4)
118   format(//,5X, 'Errors on validation sample: MAPE =',
     +                           F7.2,' %',4X, 'MSE =',E10.4 )
111   format (/,5X, 'Polynomial coefficients:',/,
     +          3X, 'ͻ',/,
     +          3X, '            Coefficient    Variable ',/,
     +          3X, 'Ķ'  )
112   format (  3X, '  a 0   ',    F17.10,'     --    ' )
113   format (  3X, '  a',I2,'   ',F17.10,'    X',I5, ' ')
114   format (  3X, '  a',I2,'   ',F17.10,'    X',I3, '   ')
115   format (  3X, '  a',I2,'   ',F17.10,'    Y',I5, ' ')
116   format (  3X, '  a',I2,'   ',F17.10,'    Y',I3, '   ')
220   format (  3X, '  a 0    ',   F16.10,'     ---   '  )
221   format (  3X, '  a 0  ',     E18.10,'     ---   '  )
222   format (  3X, '  a',I2,'   ',F17.10,'    X',I5, ' ')
223   format (  3X, '  a',I2,'   ',F17.10,'    X',I3, '   ')
224   format (  3X, '  a',I2,'  ', E18.10,'    X',I5, ' ')
225   format (  3X, '  a',I2,'  ', E18.10,'    X',I3, '   ')
226   format (  3X, '  a',I2,'  ', F18.10,'    Y',I5, ' ')
227   format (  3X, '  a',I2,'  ', F18.10,'    Y',I3, '   ')
228   format (  3X, '  a',I2,'  ', E18.10,'    Y',I5, ' ')
229   format (  3X, '  a',I2,'  ', E18.10,'    Y',I3, '  ')
119   format (  3X, 'ͼ' )
      end
