$LARGE
CĿ
C     Name: BINAR  v.2.2                                     05/21/93 03:33pm 
C                                                                             
C     Description: Initial data binarization procedure.                       
C                                                                             
C     Gregory Ivakhnenko  (c)                                                 
C
      Program  BINAR
      real           X  [allocatable] (:,:),  V  [allocatable]   (:)
      real           XX [allocatable] (:,:),  XM [allocatable] (:,:)
      integer        IV [allocatable] (:)
      integer        IN_Card (2), IXM(100), IXN(100), MM,NN, M,N
      real           PAR_Card(1)
      real*8         S,SS
      character*12   Name, RName           ! File name
      character*10   Form                  ! Initial data reading format
      character*1    NO,NON,QQ
      character*2    FNo
      common /LDAT/  JPR                   ! Initial data print flag
      automatic                            ! Put everything on stack by default
      NO  = 'N'
      NON = 'n'
C==============================================================================
C            X (M,N) - 室 ᨢ
C           IX (M,N) - 室 ᨢ  ࠬ ஢   祭 X
C        V(N), IV(N) - ࠡ稥   ࠭஢
C                 LP - ⢮ 祪  ஢
C                JPR -   室 
C              MM,NN - ⢨⥫쭮 祭 M  N 㦭 ⮫殢  ப
C  IXM(100),IXN(100) -  ஢ 㦭 ⮫殢  ப   !!? MM,NN < 100
C==============================================================================
      write (*,1111)
      write (*,999)
      write (*,2222)
C --------------------------------------------------------------------------
C           Data & parameters input and memory allocation
C ----------------------------------------------------------------------------
      call CardIN (Name,Form, M,N, MM,NN,IXM,IXN, PAR_Card,1,IN_Card,2)

      allocate ( X(MM,NN), XX(MM,NN), XM(3,NN), V(NN), IV(NN),
     +            stat = MEMERR )
      if(MEMERR .ne. 0)  stop ' Abort: Not enough storage!'

      LP    = IN_Card (1)
      JPR   = IN_Card (2)
      write(*,'(10X,A28,I2)') 'Number of points per level: ', LP
C---------------------------------------------------------------------------
C          Data input
C --------------------------------------------------------------------------
      call DATPIN( Name, Form, M,N, MM,NN, X, IXM,IXN )

      do 10 J= 1,M                              ! Take variable
         do 20 I= 1,N
20       V(I) = X(J,I)
         call RaMinVe ( 1, N,NN, V,IV)          ! Range

         K  = 0                                 ! Current point number in vector IV
         SL = 0.                                ! Level
40       SL = SL + 1.
            do 30 I= 1,LP
               K = K + 1
               if( K .gt. N ) goto 10           ! K too great IP+
               XX( J, IV(K)) = SL               ! Assign level number
30             continue

         if( K .lt. N ) goto 40                 ! All points ?
10    continue
C --------------------------------------------------------------------------
C           Results output to screen
C --------------------------------------------------------------------------
      write (*,44)
      call MATPRI( M,N, MM,NN, XX )
      write (*,*)
      write (*, 333) SL
C --------------------------------------------------------------------------
C           Calculate first and second moments (average and dispertion)
C --------------------------------------------------------------------------
      do 50 I= 1,N
         S = 0.
            do 60 J= 1,M
60          S = S + XX( J,I )

         XM( 1,I ) = S / M
         S  = 0.
         SS = 0.
            do 70 J= 1,M
            S  = S  + ( XM( 1,I ) - XX( J,I ))**2
70          SS = SS + ( XM( 1,I ) - XX( J,I ))**3
         XM( 2,I ) =  S / M
50       XM( 3,I ) = SS / M

      write (*,*)
      write (*,*) '        First and second moments: '
      call MatPri( 3,N, 3,NN, XM )
C --------------------------------------------------------------------------
C           Results output to file
C --------------------------------------------------------------------------
      write (*,'(//,10X,2A\)') 'Create report file with results ',
     +                         'of computations ?  (Y/N) -> '
      read  (*,'(A1)') QQ
      if( QQ.ne.NO .and. QQ.ne.NON) then
         io = 2
         I = SL
         write ( FNo,'(I2.2)' ) I
         RName  = FNo // '.RES'
         write (*,*) RName
         open (io, file= RName, status= 'NEW',mode= 'WRITE',err= 99 )
         write (io,*)
         write (io,*) ' * Report file of MGDH Binarization Procedure *'
C         write (io,*)
C         write (io, 777)
C         call MATPRIF( io, M,N, MM,NN, X )
C         write (io, 44)
C         call MATPRIF( io, M,N, MM,NN, XX )
         write (io,666)
C         call MatPriF ( io, 3,N, 3,NN, XM )
            do 80 I= 1,N
80          write (io,888) ( XX( J,I ), J= 1,M ), ( XM( J,I ), J= 1,3 )
         write (io, 11 ) NAME
         write (io, 22 ) M
         write (io, 33 ) N
         write (io, 222) LP
         write (io, 333) SL
         close (io)
         write (*,555) RName
      endif
C------------------------------------------------------------------------------
      deallocate ( X, XX, XM, V, IV, stat = IERR )
      if( IERR .ne. 0 ) write (*,*) ' Warning: Deallocation error!'
      write (*,*)
      stop ' '
11    format (/,10X,'Initial data file name: ',A12)
22    format (10X,'Number of variables:    M =',I3)
33    format (10X,'Number of points:       N =',I3)
44    format (/,10X,'Variables after binarization :')
111   format (5X,A3,I4)
222   format (10X,'Number of points in level: ',I3)
333   format (10X,'Number of levels         : ',F4.0)
444   format (I4,5X,100F5.0)
555   format (//,10X,'All results - in the file ',A12/)
666   format (/,4X,'Variables after binarization  &  ',
     +             'first, second and third moments: ', /)
777   format (/10X,'Initial data array :')
888   format (100F10.3)
999   format(' ',12X,'MGDH  Data  Binarization  Procedure',
     +             7X,'Version 2.2',12X,'',
     +     /,' ',12X,'    (c) Gregory Ivakhnenko',
     +             5X,'                      ',12X,'')
1111  format (/,' ',
     +'ͻ')
2222  format   (' ',
     +'ͼ')
99    stop '*** Cannot open output file ! ***'
      end
