c*********************************************************************
C    HARMONICAL INDUCTIVE LEARNING ALGORITHM
C
C
C     N - NO.OF TRAINING SET POINTS
C     NP - NO.OF TEST SET POINTS
C     NE - NO.OF EXAMIN SET POINTS
C     PT - NO.OF PREDICTION POINTS
C     JFM - MAX NO.OF FREQUENCIES
C     JF - FREEDOM OF CHOICE
C     NRM - NO.OF SERIES IN HARMONICAL TREND
C     NN = N+NP+NE
C     NPT = NN+PT
C     G(NN) - DISCRETE SIGNAL DATA
C     APR(NPT) - HARMONICAL MODEL VALUES
C     MA - NO.OF LAG POINTS FOR SMOOTHING PROCEDURE(MOVING AVERAGE
C          VALUE). IF IT IS ONE, DATA REMAINS SAME
C
C*********************************************************************
C  MAIN PROGRAM
C
       INTEGER PT
       DIMENSION G(58),PA(4,58),PA1(4,58),AP(68),APR(68),YB(68),
     * TIN(4,8,1),IST(1),C(10,10)
        DO 10 1 I=1,58
1       G(I)=1.2*SIN(I * 0.34)-2.7*COS(I * 0.59)+1.1*COS(I* 0.43)
     *  -4.3*SIN(I*1.56)+2*COS(I*1.56)
     PT=10
       
c       CALL HARMAN(N,NP,NE,NN,PT,JF,JFM,NRM,0,1,JF2,NPT)
     CALL HARMAN(50,4,4,58,PT,4,4,1,1,0,5,10,68,
     *           G,YB,AP,APR,PA,PA1,TIN,IST,C)

       STOP
       END
       

       SUBROUTINE HARMAN(N,NP,NE,NN,PT,F,FM,NRM,KA,IP,
     *                   F2,NPT,G,YB,AP,APR,PA,PA1,TIN,IST,C)
       INTEGER F,FM,PT,F2
       REAL IB(6)
       DIMENSION IST(6),PA(15,120),PA1(15,120),APR(160)
       COMMON /AB/G(120)
       COMMON /TIN/TIN(15,48)
       COMMON /BC/YB(160),AP(160),WK(31),B(31),A(31),C(31,32),W(15)
100    FORMAT(//)
101    FORMAT(5X,'FREEDOM OF CHOICE',I3/)
102    FORMAT(5X,'MAX NO.OF FREQUENCIES',I3/)
103    FORMAT(5X,'MAX.NO.OF SERIES',I3/)
104    FORMAT(5X,'LENGTH OF EXAMINING SET (C)',I4/)
105    FORMAT(5X,'LENGTH OF TESTING SET (B)',I4/)
106    FORMAT(5X,'LENGTH OF TRAINING SET (A)',I4/)
107    FORMAT(5X,'NO.OF PREDICTION POINTS',I4/)
109    FORMAT(/)
110    FORMAT(2X,7F11.3)
111    FORMAT(2X,'TIME SERIES')
112    FORMAT(10X,'OPTIMAL TREND',/,10X,'--- ---')
113    FORMAT(3X,'SERIES',I3)
114    FORMAT(3X,'NO.OF FREQUENCIES',I3)
115    FORMAT(3X,'FREE TERM',F13.5)
116    FORMAT(3X,'FREQ',12X,'COEFFS A',9X,'COEFFS B',8X,'AMPLITUDE')
117    FORMAT(F10.7,3F17.6)
118    FORMAT(2X,'ACTUAL VALUES:')
119    FORMAT(5F16.6)
120    FORMAT(2X,'ESTIMATED VALUES:')
121    FORMAT(5X,'PREDICTED VALUES:')
122    FORMAT(I8,2F28.5)
123    FORMAT(I8,F53.5)
124    FORMAT(/)
127    FORMAT(11X,'NO CORRECT DECISION')

       NK=N+NP+NE
       N1=N+NP
       NKT=NK+PT
       PI=3.1415926535/2.
       WRITE(3,100)
       WRITE(3,106)N
       WRITE(3,105)NP
       WRITE(3,104)NE

       WRITE(3,102)FM
       WRITE(3,101)F
       WRITE(3,107)PT
       WRITE(3,103)NRM
       WRITE(*,109)
       WRITE(*,111)
       WRITE(*,110)(G(I),I=1,NN)
       NR=1
 1     IT=0
 2     IT=IT+1 
       M=0
 3     M=M+1
       MP=2*M
       DO 4 I=1,NK
       IF(NR-1)6,6,5
 6     YB(I)=G(I)
       GOTO 4
 5     YB(I)=PA(IT,I)
 4     CONTINUE
       CALL WB(N,M,M1,IER,KA)
       IF(IER)77,998,77
 77    CALL FRIQ(M,M1)
       DO 7 J=1,M
       AN=1.-WK(J)**2
       BN=WK(J)/SQRT(AN)
 7     W(J)=PI-ATAN(BN)
       CALL WB1(M,M1,IER)
       IF(IER)78,999,78
78     CALL COEF(M,N,IER) 
       IF(IER)79,997,79
 79    B1=0.
       B2=0.
       B3=0.
       D1=0.
       D2=0.
       D3=0.
       M1=M+1
       NKM=NK-M
       DO 11 I=M1,NKM
       R=0.
       DO 12 J=1,M 
     I1=I+J-1

       I2=I-J+1
 12    R=R+A(J)*(YB(I1)+YB(I2)-2*B(MP+1))
       IM=I+M
       MI=I-M
       R=(YB(IM)+YB(MI)-R-2*B(MP+1))**2
       IF(I-(N-M))80,80,13
 80    B1=B1+R
       GOTO 11
13     IF(I-(N1-M))81,81,14
81     B2=B2+R
       GOTO 11
 14    B3=B3+R
11     CONTINUE
       AN=N-MP
       BN=B1/AN
       IB(1)=SQRT(BN)
       AN=NP
       BN=B2/AN
       IB(2)=SQRT(BN)
       DO 15 I=1,MP
       R=0.0
       DO 16 J=1,M
       AI=I
       D=W(J)*AI
       J2 = 2*J
       J21 = J2-1
 16    R=R+B(J21)*SIN(D)+B(J2)*COS(D)
       D1=D1+(YB(I)-B(MP+1)-R)**2
 15    AP(I)=R
       DO 17 I=M1,NKM
       I1=I-M
       R=-AP(I1)
       DO 18 J=1,M
       I1=I+J-1
       I2=I-J+1
18     R=R+A(J)*(AP(I1)+AP(I2))
       I2=I+M
       AP(I2)=R
       D=(YB(I2)-R-B(MP+1))**2
       IF(I2-N)82,82,19
82     D1=D1+D
       GOTO 17

19     IF(I2-N1)83,83,20
83     D2=D2+D
       GOTO 17
20     D3=D3+D
17     CONTINUE
       AN=N
       BN=D1/AN
       IB(4)=SQRT(BN)
       AN=NP
       BN=D2/AN
       IB(5)=SQRT(BN)
       IF(NE)21,21,22
21     IB(3)=0.
       IB(6)=0.
       GOTO 23
22     IB(3)=SQRT(B3/NE)
       IB(6)=SQRT(D3/NE)
23     IF(IT-1)25,84,25
84     IF(M-F)24,24,25
 24    KP=(NR-1)*8+1
       IF(NR-1)26,26,27
 26    TIN(M,KP)=0.
       GOTO 28
27     TIN(M,KP)=IT
28     TIN(M,KP+1)=M
       DO 29 I=1,6 
     KS=KP+1+I
29     TIN(M,KS)=IB(I)
       DO 30 I=1,NK
30     PA1(M,I)=YB(I)-AP(I)-B(MP+1)
       GOTO 34
 25    R=0.
       IZ=0
       DO 31 I=1,F
       KP=(NR-1)*8+IP+2
       D=TIN(I,KP)
       IF(R-D)85,85,31
85     R=D
       IZ=I
31     CONTINUE
55     IF(R-IB(IP))34,34,86
86     DO 32 I=1,NK
32     PA1(IZ,I)=YB(I)-AP(I)-B(MP+1)
       KP=(NR-1)*8+1
       DO 33 I=1,6
       KS=KP+1+I
33     TIN(IZ,KS)=IB(I)
       TIN(IZ,KP)=IT
       TIN(IZ,KP+1)=M
       IF(NR-1)34,87,34
87     TIN(IZ,KP)=0.0
34     IF(M-FM)3,88,88
88     IF(NR-1)89,35,89
89     IF(IT-F)2,35,35
35     CALL PRI(NR,IP,F)
       NR=NR+1
       DO 136 J=1,F
       DO 136 I=1,NK
136    PA(J,I)=PA1(J,I)
       IF(NR-NRM)1,1,90
90     WRITE (3,100)
       WRITE (3,112)
       IZ=1
       NR=1
       P1=TIN(1,IP+2)
       DO 36 I=1,NRM
       KS=(I-1)*8+IP+2
       DO 36 J=1,F
       D=TIN(J,KS)
       IF(D-P1)91,36,36
91     NR=I
       P1=D
       IZ=J
36     CONTINUE
       KP=(NR-1)*8+2
       IST(NR)=TIN(IZ,KP)
       I1=NR-1
       IF(I1)92,382,92
92     CONTINUE
       DO 37 I=1,I1
       I2=NR-I
       KS=I2*8+1
       IZ=TIN(IZ,KS)
       KS=(I2-1)*8+2

37     IST(I2)=TIN(IZ,KS)
382    DO 38 I=1,NKT
       APR(I)=0.0
       IF(I-NK)39,39,40
39     YB(I)=G(I) 
       GOTO 38
40     YB(I)=0.0
38     CONTINUE 
381    IZ=1
41     M=IST(IZ)
       MP=2*M
       CALL WB(N,M,M+1,IER,KA)
       IF(IER)999,999,42
42     CALL FRIQ(M,M+1)
       DO 43 J=1,M
       AN=1.0-WK(J)**2
       BN=WK(J)/SQRT(AN)
43     W(J)=PI-ATAN(BN)
       CALL RANG(M,W)
       CALL WB1(M,M+1,IER)
       IF(IER)93,998,93
93     CONTINUE
       CALL COEF(M,N,IER)
       IF(IER)94,997,94
94     CONTINUE
       WRITE(3,113)IZ
       WRITE(3,115)B(MP+1)
       WRITE(3,114)M
       WRITE(3,116)
       DO 46 I=1,M
       I2 = I*2
       I21 = I2-1
       BN=B(I21)**2+B(I2)**2
       P1=SQRT(BN)
46     WRITE(3,117)W(I),B(I21),B(I2),P1
       DO 47 I=1,MP
       R=0.0
       DO 48 J=1,M
       AI=I
       D=W(J)*AI
       J2 = J*2
       J21 = J2-1

 48    R=R+B(J21)*SIN(D)+B(J2)*COS(D)
       APR(I)=APR(I)+R+B(MP+1)
47     AP(I)=R
       M1=M+1
       NKM=NK+PT-M
       DO 53 I=M1,NKM
       I1=I-M
       R=-AP(I1)
       DO 49 J=1,M
       IJ1=I+J-1
       IJ2=I-J+1
 49    R=R+A(J)*(AP(IJ1)+AP(IJ2))
       I2=I+M
       AP(I2)=R
 53    APR(I2)=APR(I2)+AP(I2)+B(MP+1)
       DO 50 I=1,NK
 50    YB(I)=YB(I)-AP(I)-B(MP+1)
       IZ=IZ+1
       IF(IZ-NR)41,41,95
95     CONTINUE
       WRITE(3,100)
       WRITE(3,118)
       WRITE(3,110)(G(I),I=1,NN)
       WRITE(3,109)
       WRITE(3,120)
       WRITE(3,110)(APR(I),I=1,NN)
       GM=0.0
       DO 54 IH=1,NN
       GM=GM+G(IH)
54     CONTINUE
       GM=GM/NN
       Cf1=0.0
       CD=0.0
       DO 10 IH=1,NN
       CK=G(IH)-APR(IH)
       CN=CN+CK**2
10     CD=CD+(G(IH)-GM)**2
       CK=SQRT(CN/CD)
       WRITE(3,133)CK
133    FORMAT(/5X,'RESIDUAL SUM OF SQUARES =',5X,E18.7/)
       WRITE(3,100)
       WRITE(3,121)

       I1=N1+1
       I2=NK+PT
       DO 51 I=I1,I2
       IF(I-NK)96,96,52
96     CONTINUE
       WRITE(3,122)I,G(I),APR(I)
       GOTO 51
 52    WRITE(3,123)I,APR(I) 
 51    CONTINUE

       GOTO 1001
999    WRITE(*,124)
       GOTO 1000
998    WRITE(*,124)
       GOTO 1000
997    WRITE(*,124)
1000   WRITE(*,127)
1001   RETURN
       END

       SUBROUTINE COEF(M,N,IER)
       COMMON /BC/ Y(160),Y1(160),VK(31),B(31),A(31),HM(31,32),W(15)
       K=2*M
       K1=K+1
       DO 1 I=1,K1
       HM1=0.0
       IF(I-K)2,2,3
 2     AI=I
       BI=(AI+1.25)/2.
       II=INT(BI)
       BI=(AI+0.1)/2.
       AI=INT(BI)
       TI=BI-AI
       DO 4 J=I,K
       AJ=J
       BJ=(AJ+1.25)/2.
       JJ=INT(BJ)
       BJ=(AJ+0.1)/2.
       AJ=INT(BJ)
       TJ=BJ-AJ
       W1=W(II)-W(JJ)
       W2=W(II)+W(JJ)
       IF(II-JJ)6,5,6
 5     IF(ABS(TI-TJ)-0.01) 8,30,30 
 30    S1=0.0
       GOTO 9
 8     S1=N
       GOTO 9
 6     AN=N
       CN=AN*W1/2.
       BN=W1/2.
       S1=SIN(CN)/SIN(BN)
 9     AN=N
       CN=AN*W2/2.
       BN=W2/2.
       S2=SIN(CN)/SIN(BN)
       AN=N+1

       BN=AN*W1/2.
       CN=AN*W2/2.
       CN1=COS(BN)
       CN2=COS(CN)
       SN1=SIN(BN)
       SN2=SIN(CN)
       IF(TI-0.25)11,10,10
   10  IF(TJ-0.25)13,12,12
 12    HM(I,J)=S1*CN1-S2*CN2
       GOTO 40
 13    HM(I,J)=S2*SN2+S1*SN1
       GOTO 40
11     IF(TJ-0.25)15,14,14
 14    HM(I,J)=S2*SN2-S1*SN1
       GOTO 40
 15    HM(I,J)=S1*CN1+S2*CN2
40     HM(I,J)=0.5*HM(I,J)
  4    CONTINUE
       IF(TI-0.25)17,16,16
16     Y1(1)=SIN(W(II))
       Y1(2)=SIN(2*W(II))
       GOTO 18
 17    Y1(1)=COS(W(II))
       Y1(2)=COS(2*W(II))
 18    WK1=COS(W(II))
       DO 19 J=3,M
       Y1(J)=2.*WK1*Y1(J-1)-Y1(J-2)
19     HM1=HM1+Y1(J)*Y(J)
       HM(I,K+2)=HM1+Y1(1)*Y(1)+Y1(2)*Y(2)
       IF(TI-0.25)21,20,20
20     AN=N+1
       AN=AN*W(II)/2.
       H1=SIN(AN)
       GOTO 22
21     AN=N+1
       AN=AN*W(II)/2.
       H1=COS(AN)
22     AN=N
       BN=W(II)/2.
       CN=AN*BN
       HM(I,K1)=H1*SIN(CN)/SIN(BN)
       GOTO 24

  3    HM(I,K1)=N
       H1=0.
       DO 23 J=1,N
 23    H1=H1+Y(J)
       HM(I,K+2)=H1
24     IF(I-2)1,25,25
25     I1=I-1
       DO 26 J=1,I1
26     HM(I,J)=HM(J,I)
 1     CONTINUE
       K11 = K1+1
       CALL GAUSS(HM,K1,K11,B,IER)
       RETURN
       END
       

       SUBROUTINE FRIQ(M,M1)
       COMMON /BC/YB(160),AP(160),WK(31),CO(31),A(31),FI(31,32),W(15)
       M1 = M+1
       DO 1 I=1,M
       DO 1 J=1,M1
 1     FI(I,J)=0.0
       FI(1,2)=1.0
       IF(M-1)11,27,11
11     FI(2,1)=-1.0
       FI(2,3)=2.0
       IF(M-2)2,2,12
12     DO 3 I=3,M
       I1=I+1
       DO 4 J=2,I1
 4     FI(I,J)=2*FI(I-1,J-1)-FI(I-2,J)
3      FI(I,1)=-FI(I-2,1)
2      M2=M-1
       DO 5 I=1,M2
       DO 5 J=1,M1
 5     FI(M,J)=FI(M,J)-FI(I,J)*A(I+1)
27     FI(M,1)=FI(M,1)-A(1)
       DO 6 I=1,M1
 6     CO(I)=FI(M,I)
       EP=0.000001
       EPS2=0.000001
       EPS3=0.0001
       MAX=25
       EPS=0.000001
       EPS1=0.001
       ETA=0.00001
       DO 66 I=1,M
66     WK(I)=0
       CALL NEW(M1,M,MAX,EPS,EPS1)
       RETURN
       END

       SUBROUTINE FUNC(A,N1,R,F)
       DIMENSION A(31)
       N=N1-1
       F=A(1)
       DO 1 I=1,N
 1     F=F*R+A(I+1)
       RETURN
       END

       SUBROUTINE GAUSS(A,N,L,X,KGA)
       DIMENSION A(31,32),X(31)
       KGA = 1
       L = N+1
       NN=N-1
       DO 99 K=1,NN
       J=K
       KK=K+1
       DO 100 I=KK,N
       IF(ABS(A(J,K)).LT.ABS(A(I,K)))J=I
 100   CONTINUE
       IF(J.Eq.K)GOTO 11
       DO 300 I=1,L
       T=A(K,I)
       A(K,I)=A(J,I)
       A(J,I)=T
  300  CONTINUE
  11   DO 88 J=KK,N
       IF(A(K,K).EQ.0.) GOTO 600
       D=-A(J,K)/A(K,K)
       DO 400 I=1,L
       A(J,I)=A(J,I)+D*A(K,I)
 400   CONTINUE
  88   CONTINUE
  99   CONTINUE
       IF(A(N,N).EQ.0.) GOTO 600
       X(N)=A(N,L)/A(N,N)
       NN=N-1

       DO 500 J=1,NN
       K=N-J
       SUM=0.0
       NNN=N-K
       DO 200 JJ=1,NNN
       M=K+JJ
       SUM=SUM+A(K,M)*X(M)
 200   CONTINUE
       IF(A(K,K).EQ.0.)GOTO 600
       X(K)=(A(K,L)-SUM)/A(K,K)
 500   CONTINUE
       GOTO 800
600    KGA = 2
       WRITE(*,700)
700    FORMAT(5X,' SINGULAR')
800    RETURN
       END

       SUBROUTINE NEW(N1,N,MAX,EPS,EPS1)
       DIMENSION DB(31)
       COMMON /BC/YB(160),AP(160),C(31),AD(31),A(31),FI(31,32),W(15)
       DO 11 I=1,N1
11     DB(I)=AD(I)
       DO 12 I=1,N1
       I1=N1+1-I
12     AD(I1)=DB(I)
       I=N
       J=1
       N2=N1

1      IF(I-1)20,20,2
2      R=1.0 
       M=0 
     DO 3 I1=1,I
3      DB(I1)=(N2-I1)*AD(I1) 
       F2=1.0
4      CALL FUNC(AD,N2,R,F)
       CALL FUNC(DB,I,R,F1)
       IM=M+1
       IF(ABS(F1)-EPS1)7,7,8
 8     F2=F1
 7     R=R-F/F2
       M=M+1
       IF(M-MAX)10,5,5
10     IF(ABS(F)-EPS)5,5,4
5      C(J)=R
       J=J+1

       DO 6 I1=2,I
6      AD(I1)=AD(I1)+AD(I1-1)*R  !!!
       I=I-1
       N2=N2-1
       GOTO 1

20     C(J)=-AD(2)/AD(1)
       RR=-AD(2)/AD(1)
       RETURN
       END


       SUBROUTINE PRI(NR,IP,F)
       INTEGER F
       DIMENSION SERV(6)
       COMMON /TIN/TIN(15,48)
 10    FORMAT(//,1X,'SERIES',I2)
11     FORMAT(2X,'TRNO',2X,'FRNO',4X,'BAL A',
     1 6X,'BAL B',6X,'BAL C',6X,'ERR A',6X,'ERR B',6X,
     2 'ERR C',/)
 12    FORMAT(3X,I3,2X,I4,6E11.3)
 13    FORMAT(3X,'----------------')
       K=1
       KP=(NR-1)*8+IP+2
       P=TIN(1,KP)
       IF(F-1)7,4,7
 7     DO 1 I=2,F
       IF(TIN(I,KP)-P)2,1,1
 2     P=TIN(I,KP)
       K=I
 1     CONTINUE
4      WRITE(3,10)NR
       WRITE(3,11)
       KP=(NR-1)*8+1

       DO 3I=1,F
       DO 5 J=1,6
       KS=KP+1+J
 5     SERV(J)=TIN(I,KS) 
       MT=TIN(I,KP)
       MF=TIN(I,KP+1)
       WRITE(3,12)MT,MF,(SERV(J),J=1,6)
       IF(I-K)3,6,3
 6     WRITE(3,13)
 3     CONTINUE
       RETURN
       END

       SUBROUTINE RANG(N,B)
       DIMENSION B(15)
       DO 1 I=1,N
       I1=I+1
       IF(I1-N)7,7,3
 7     DO 1 J=I1,N
       IF(B(I)-B(J))1,1,2
 2     R=B(I)
       B(I)=B(J)
       B(J)=R
 1     CONTINUE
 3     RETURN
       END
       
      SUBROUTINE WB(N1,M,M1,IER,KA)
       COMMON /BC/ X(160),Y(160),Y1(31),Y2(31),A(31),C(31,32),W(15)
       N=N1-2
       M1=M+1
       NM=N-M
       DO 1 I=1,N
 1     Y(I)=X(I+2)-X(I)
       DO 2 J=1,M1
        Y1(J)=0.0
        DO 2 I=1,M
2       C(I,J)=0.0
       DO 3 I=M1,NM
        K=I-M
        R=K
        E=1.0/R
        DO 4 J=1,M1
            I1=I+J-1
            I2=I-J+1
            Y2(J)=Y1(J)+Y(I1)+Y(I2)
                IF(KA-0)4,10,4
10              Y2(J)=Y2(J)-Y1(J)
 4     Y1(J)=Y2(J)
 8     DO 5 K1=1,M
       DO 5 J=K1,M1
       E1=Y2(K1)*Y2(J)
       IF(KA-2)5,11,5
11     E1=E1*E
 5     C(K1,J)=C(K1,J)+E1
       IF(KA-2)3,12,12
12     K=K-1
       IF(K-0)13,3,13
13     DO 7 J=1,M1
       I1=I+J-1-K
       I2=I-J+1-K
7      Y2(J)=Y2(J)-Y(I1)-Y(I2)
       GOTO 8
3      CONTINUE

       IF(M-1)14,77,14
14     DO 6 I=2,M
       I1=I-1
       DO 6 J=1,I1
 6     C(I,J)=C(J,I)

77     CALL GAUSS(C,M,M1,A,IER)
       RETURN
       END
       
       SUBROUTINE WB1(M,M1,IER)
       COMMON /BC/ YB(160),AP(160),WK(31),B(31),A(31),C(31,32),W(15)
       M1 = M+1
       DO 1 I=1,M
       DO 1 J=1,M1
       AJ=J-1
       AJ=AJ*W(I)
 1     C(I,J)=COS(AJ)
       CALL GAUSS(C,M,M1,A,IER)
       RETURN
       END
       
c*********************************************************************
C    HARMONICAL INDUCTIVE LEARNING ALGORITHM
C
C
C     N - NO.OF TRAINING SET POINTS
C     NP - NO.OF TEST SET POINTS
C     NE - NO.OF EXAMIN SET POINTS
C     PT - NO.OF PREDICTION POINTS
C     JFM - MAX NO.OF FREQUENCIES
C     JF - FREEDOM OF CHOICE
C     NRM - NO.OF SERIES IN HARMONICAL TREND
C     NN = N+NP+NE
C     NPT = NN+PT
C     G(NN) - DISCRETE SIGNAL DATA
C     APR(NPT) - HARMONICAL MODEL VALUES
C     MA - NO.OF LAG POINTS FOR SMOOTHING PROCEDURE(MOVING AVERAGE
C          VALUE). IF IT IS ONE, DATA REMAINS SAME
C
C*********************************************************************
C      MAIN PROGRAM
C
       INTEGER PT
       DIMENSION GY(120)
       COMMON /AB/ G(120)
       OPEN(3,FILE='output.dat') 
     OPEN(8,FILE='ts.dat', status='unknown', mode='read')
       WRITE(3,4)
4      FORMAT(5X,' LAYERED    HARMONICAL ALGORITHM'/)
       WRITE(*,110) 
110    FORMAT(3X,'GIVE NO.OF TRAIN, TEST & EXAM PTS?')

C       READ(*,*)N,NP,NE
    N=45
    NP=1
    NE=1
       NN=N+NP+NE
       WRITE(*,112)
112    FORMAT(3X,'GIVE NO.OF PRED PTS??')

C       READ(*,*)PT
    PT=5
       NPT=NN+PT

     do 10 I=1,NN
10     READ(8,444) G(I)  ! read data seria
      write(*,'(120F7.3)')(G(I),I=1,NN)
444    FORMAT(F7.3)

       FAX=G(1)
       DO 5 I=2,NN
       IF(G(I).GT.FAX) FAX=G(I)
 5     CONTINUE
       DO 6 I=1,NN 
     G(I)=G(I)/FAX
 6     CONTINUE

       WRITE(*,222) 
222    FORMAT(3X,'GIVE MOVING AVERAGE VALUE (=1 or n)?')

C       READ(*,111)MA 
    MA=1
111    FORMAT(I2)
       WRITE(*,333)
333    FORMAT(3X,'HOU MANY SERIES?')

C       READ(*,111)NRM
    NRM=3
       WRITE(*,114)
114    FORMAT(3X,'GIVE MAX NO.OF FREQS^=15)77')

C       READ(*,*)JFM
    JFM=8
       JF2=2*JFM+2
       WRITE(*,115)
115    FORMAT(3X,'GIVE FREEDOM OF CHOICE^ MAX FREQS)?')

C       READ(*,*)JF
    JF=7
       SMA=0.0
       DO 7 I=1,MA
 7     SMA=SMA+G(I)
       SMA=SMA/MA
       GY(1)=SMA
       IX=1
       MHR=MA+1
       DO 8 I=MHR,NN
       IX=IX+1
       IX1=IX-1
       IMA=I-MA
       GY(IX)=GY(IX1)+(G(I)-G(IMA))/MA
 8     CONTINUE
       DO 9 I=1,IX 
     G(I)=GY(I)
 9     CONTINUE
       CALL HARMAN(N,NP,NE,NN,PT,JF,JFM,NRM,0,1,JF2,NPT)
       STOP
       END