CĿ
C     Name: GRAF  v.1.1                                      06/24/92 03:00pm 
C                                                                             
C     Description: This subroutine displays optionaly 2 graphes               
C                                                                             
C     Gregory Ivakhnenko (c) 1992.                                            
C
         include       'FGRAPH.FI'

      subroutine GRAF ( INum, Klp, Var, YMin,YMax, YMin2,YMax2,
     +                  N1,N2, N12,N22, NN1,NN2, Bananas, Ananas )
         include       'FGRAPH.FD'
      real           Bananas( NN1 ), Ananas( NN2 ), Var
      integer*2      dummy,cols,rows, ICoX,ICoAxe,ICo1,ICo2,
     +               X1,Y1,Y2,YAX,XAX, MaxRows,IWarnRow,IYnameRow
      character*9    Yname,  Yname2,   Xname,  VarName, str
      character*4    str_num
      character*10   Form,   VarForm
      character*20   GrName, str_name
      logical        MODE
      external       MODE

      record /xycoord/     xy
      record /videoconfig/ scr
      record /rccoord/     curpos
      common /LMODE/    scr
      common /LGRAF/    VarForm,VarName,GrName,Xname,Yname,Yname2,Form
      common /LAXE/     cols,rows, X1,Y1,Y2, ICoX,ICoAxe,ICo1,ICo2,
     +                  YAX,XAX, MaxRows,IWarnRow,IYnameRow
      automatic
C==============================================================================
C        INum       - number of graphs (1\2)
C        Klp        - key for waiting ENTER at the end of graph output
C        Var,VarName- current output variable value and name
C        VarForm    - variable output format
C        GrName     - genaral picture name
C        Xname      - X axe name
C        Yname      - Y axe name of virst variable
C        Yname2     - Y axe name of second variable
C        Form       - output function values format at Y axe
C        YMin,YMax  - Minimum and Maximum of first variable values
C                     (when equal automatical calculation)
C        YMin2,YMax2- Minimum and Maximum of first variable values (-"-)
C        VMin,VMax  - global Minimum & Maximum
C        N1,N2      - first and last first variable point number
C        N12,N22    - first and last second variable point number
C        L1,L2      - global Minimum & Maximum of points number
C        Bananas, Ananas - first and second variables array
C        NN1,NN2    - arrays dimension
C        xy         - line drawing record
C        scr        - video configuration record
C        curpos     - text cursor position record
C        IRET       - returning flag (1\0)
C  Init_Axe :
C        rows,cols  - text rows and columns number for current mode
C        xwidth, yheight - screen pixel number for current mode
C        Y0, X0     - origin of coordinates coordinate
C        X1, Y1     - Maximal point coordinates in system of coordinates
C        Y2         - number of pixel for lifting up graphs from origin on axe Y
C        ICoX       - Xname colour
C        ICoAxe     - Yname colour
C        ICo2       - Yname2 colour
C        YAX,XAX    - axes sizes
C  PROPOR :
C        SLOW  - low mark value
C        ILOW  - low mark position in pixels
C        ID,D  - number of pixels and function in interval
C        DY    - coefficient for calculation of function position
C        KR    - number of intervals on axe
C==============================================================================
C      if( INum .ne. 1  .and.  INum .ne. 2 ) return
      call clearscreen( $GCLEARSCREEN )
C ---------------------------------------------------------------------------------
C           Write axe & graph names
C -----------------------------------------------------------------------------
      dummy = setcolor( ICoAxe )
      dummy = settextcolor( ICoX )
      call settextposition( rows/12 - 1, cols - 45, curpos )
      call outtext( GrName )                                ! Graf Name
      dummy = settextcolor( ICoAxe )
      call settextposition( rows/12,     cols - 20, curpos )
C      call settextposition( rows/12 - 1, cols - 20, curpos )
      call outtext( VarName )                               ! Variable
      call settextposition( rows/12,     cols - 11, curpos )
C      call settextposition( rows/12 - 1, cols - 11, curpos )
      write (str_name, VarForm ) Var                        ! Variable value
      call outtext( str_name )
C -----------------------------------------------------------------------------
C           Draw X axe
C -----------------------------------------------------------------------------
      call moveto ( XAX-10,  2, xy )
      dummy = lineto ( XAX, 0)
      call moveto ( XAX-10, -2, xy )
      dummy = lineto ( XAX, 0)
      call moveto ( 0, 0, xy )
      dummy = lineto ( XAX-2, 0)
C -----------------------------------------------------------------------------
C           Draw Y axe
C -----------------------------------------------------------------------------
      call moveto ( 2, YAX+10, xy )
      dummy = lineto ( 0, YAX)
      call moveto (-2, YAX+10, xy )
      dummy = lineto ( 0, YAX)
      call moveto ( 0, 0, xy )
      dummy = lineto ( 0, YAX+2)
C        dummy = setpixel ( X1, Y1)
C -----------------------------------------------------------------------------
C           Found Max & Min for graph 1
C -----------------------------------------------------------------------------
      if( YMax .ne. YMin )  then
          VMin = YMin
          VMax = YMax
      else                                      ! Found Max & Min
         call MinMaxN1 (SY, VMin,VMax, NMin,NMax, N1,N2,NN, Bananas)
      endif

      if( INum .ne. 2 ) then
         N12 = N1
         N22 = N2
         goto 30
      endif
C -----------------------------------------------------------------------------
C           Found Max & Min for graph 2
C -----------------------------------------------------------------------------
      if( YMax2 .ne. YMin2 )  then
          VMin2 = YMin2
          VMax2 = YMax2
      else                                      ! Found Max & Min
         call MinMaxN1 ( SY, VMin2,VMax2, NMin2,NMax2, N12,N22,
     +                   NN2, Ananas )
      endif
      VMin = Min ( VMin,VMin2 )
      VMax = Max ( VMax,VMax2 )

30    SY = VMax - VMin
C      call settextposition( rows/12,     cols - 20, curpos )
C      write ( str_name, '(A5,E9.3)')  'Max =', VMax
C      call outtext( str_name )                              ! Max output
C      call settextposition( rows/12 + 1, cols - 20, curpos )
C      write ( str_name, '(A5,E9.3)')  'Min =', VMin
C      call outtext( str_name )                              ! Min output
      if( SY .eq. 0 ) then
          SLOW = VMin                           ! Draw line = VMin
          ILOW = -Y2
          KR = 1
          ID = 0
          D  = 0.
      else
         dummy = Y2                             ! Divide and center Y
         call PROPOR ( SY, Y1,dummy, VMax,VMin, SLOW,ILOW, ID,DY,D, KR)
      endif
C -----------------------------------------------------------------------------
C           Y axe
C -----------------------------------------------------------------------------
      IY = rows - 1
      dummy = settextcolor( ICoX )
      S = SLOW
      J = ILOW
      do 20 I= 1,KR
         call moveto ( -4, J, xy )              ! Draw Y sticks
         dummy = lineto ( 0, J )
         J1 = IY - ((MaxRows * J) / Y1)         ! Calculate text row number
         if( J1 .gt. IYnameRow+1 ) then         ! Write Y sticks values
            call settextposition( J1, 0, curpos )
            write ( str, Form ) S
            call outtext( str )
         endif
         if(S .eq. 0.) then
            call setlinestyle( #0111 )          ! Grid 0 fat line 1
C            dummy = setcolor ( ICoX )
         else
            call setlinestyle( #0101 )
         endif
         call moveto ( 0, J, xy )               ! Draw grid Y lines
         dummy = lineto ( X1, J )
         call setlinestyle( #FFFF )
C         dummy = setcolor( ICoAxe )
         S = S + D
         J = J + ID
20       if( J .lt. YAX+5 ) exit
C -----------------------------------------------------------------------------
C           X axe
C -----------------------------------------------------------------------------
      L1 = Min0( N1, N12)                       ! Found points interval
      L2 = Max0( N2, N22)
      call settextposition( rows, 7, curpos )   ! Write first point number
      write (str, '(I4)') L1
      call outtext( str )

      IDX = (X1 - 15) / (L2 - L1)               ! X increment
      IXD = 0                                   ! X number type flag
      J   = 0
      J1  = 0

      IX1 = 0                                           ! X point coordinate
      IY1 =(( Bananas(N1) - VMin ) * DY ) - Y2 - 1      ! Y point coordinate
      if( INum .eq. 2 ) IY12 = (( Ananas(N12) - VMin ) * DY ) - Y2 - 1
                                                        ! Y point coordinate 2
      do 10 I= L1+1, L2
         IX = ( I - L1 ) * IDX

         if( I.gt.N12 .and. I.le.N22 .and. INum.eq.2 )  then
            IY2 = (( Ananas(I) - VMin) * DY) - Y2 - 1   ! Calculate coordinates 2
               dummy = setcolor( ICo2 )
               call moveto ( IX1, IY12,  xy )           ! Draw graph 2
               dummy = lineto ( IX, IY2 )
               IY12 = IY2
         endif

         if( I .gt. N1  .and.  I .le. N2 )  then
            IY = (( Bananas(I) - VMin) * DY) - Y2 - 1   ! Calculate coordinates 1
               dummy = setcolor( ICo1 )
               call moveto( IX1, IY1, xy )      ! Draw graph 1
               dummy = lineto( IX, IY )
               IY1 = IY
         endif

        IXD = IXD + IDX                         ! Calculate flag for numbers
        J1  = J1  + IDX
        if( IXD .ge. 10)  then                  ! Write point numbers
           dummy = setcolor( ICoAxe )
           call moveto( IX, 4, xy )             ! Draw sticks axe X
           dummy = lineto( IX, 0 )
           IXD= 0
           J  = J + 1
           if( J .ge. 4  .or.  J1 .ge. 35) then ! Write point numbers
              I1 = ((70 * IX ) / X1) + 7.5      ! Calculate number text position
              call settextposition( rows, I1, curpos )
              write (str_num, '(I4)') I
              call outtext ( str_num )

              call setlinestyle( #0101 )        ! Grid X lines
              call moveto ( IX, 0, xy )
              dummy = lineto ( IX, Y1-15 )
              call setlinestyle( #FFFF )
              J = 0
              J1= 0
           endif
        endif
        IX1 = IX
10    continue

      dummy = settextcolor( ICoAxe )
      call settextposition( rows, cols-9, curpos )
      call outtext( Xname )                                 ! X name
      dummy = settextcolor( ICo1 )
      call settextposition( IYnameRow, 0, curpos )          ! Y name
      call outtext( Yname )
      if( INum .eq. 2 )  then
         dummy = settextcolor( ICo2 )
         call settextposition( IYnameRow, 12, curpos )
         call outtext( Yname2 )                             ! Write Y name 2
      endif

      if( Klp .ne. 0)  then                   ! PAUSE message
         I = settextcolor( 16 )
         call settextposition( IWarnRow, 12, curpos)
         call outtext( 'Pause - press Enter ' )
         read (*,*)                           ! Wait for ENTER key to be pressed
         call settextposition( IWarnRow, 12, curpos)
         call outtext( 'Wait a bit please...' )
      endif

      return
      end
