CĿ
C     Name: GRAF2  v.1.1                                     05/28/93 01:09am 
C                                                                             
C     Description: This subroutine displays optionaly 2 graphes               
C                                                                             
C     Gregory Ivakhnenko  (c)                                                 
C
      include     'FGRAPH.FI'
      interface to function  Any_Key ()
      integer*2  Any_Key [C]
      end

      subroutine GRAF ( INum, Ikl, Klp, Var,Var2, Ymin,Ymax,
     +                  N1,N2, N12,N22, NN1,NN2, Bananas, Ananas )

      include       'FGRAPH.FD'
      real           Bananas( NN1 ), Ananas( NN2 ), Var,Var2, Ymin,Ymax
      character*9    Yname,   Xname, str
      character*4    str_num
      character*12   Form,    Yname2
      character*10   VarForm
      character*20   VarName, VarName2
      character*30   GrName,  str_name
      integer*2      dummy,cols,rows, ICoX,ICoAxe,ICo1,ICo2,
     +               X1,Y1,Y2,YAX,XAX, MaxRows,IWarnRow,IYnameRow
      integer*2      Any_Key [extern]
      integer        INum, IKl, Klp, N1,N2, N12,N22, NN1,NN2

      record /xycoord/     xy
      record /rccoord/     curpos
      record /videoconfig/ scr
      common /LMode/       scr
      common /LGraf/    VarForm, VarName, VarName2, GrName, Xname,
     +                  Yname,   Yname2,  Form
      common /LAxe/     cols, rows, X1,Y1,Y2, ICoX, ICoAxe, ICo1,ICo2,
     +                  YAX, XAX,   MaxRows, IWarnRow, IYnameRow
      common /LTmp/     L1, IDX, DY, IX1, IY1,IY12
      automatic
C==============================================================================
C        Ikl        - loop variable
C        INum       - number of graphs (1\2)
C        Klp        - key for waiting ENTER at the end of graph output
C        Var,VarName- current output variable value and name
C        VarForm    - variable output format
C        GrName     - genaral picture name
C        Xname      - X axe name
C        Yname      - Y axe name of virst variable
C        Yname2     - Y axe name of second variable
C        Form       - output function values format at Y axe
C        Ymin,Ymax  - minimum and Maximum of first variable values
C                     (when equal automatical calculation)
C        N1,N2      - first and last first variable point number
C        N12,N22    - first and last second variable point number
C        L1,L2      - global minimum & Maximum of points number
C        Bananas, Ananas - first and second variables array
C        NN1,NN2    - arrays dimension
C        xy         - line drawing record
C        scr        - video configuration record
C        curpos     - text cursor position record
C  Init_Axe :
C        rows,cols  - text rows and columns number for current mode
C        xwidth, yheight - screen pixel number for current mode
C        Y0, X0     - origin of coordinates coordinate
C        X1, Y1     - Maximal point coordinates in system of coordinates
C        Y2         - number of pixel for lifting up graphs from origin on axe Y
C        ICoX       - Xname colour
C        ICoAxe     - Yname colour
C        ICo2       - Yname2 colour
C        YAX,XAX    - axes sizes
C        MaxRows    -
C        IWarnRow   -
C        IYnameRow  -
C  PROPOR :
C        SLow  - low mark value
C        ILow  - low mark position in pixels
C        ID,D  - number of pixels and function in interval
C        DY    - coefficient for calculation of function position
C        KR    - number of intervals on axe
C==============================================================================
      if( Ikl .le. 1 )  call clearscreen( $GCLEARSCREEN )
C -----------------------------------------------------------------------------
C           Write axe & graph names
C -----------------------------------------------------------------------------
      dummy = settextcolor ( ICo2 )
      call  settextposition ( rows, cols - 52, curpos )
      call  outtext ( GrName )                              ! Graf Name

      dummy = settextcolor ( ICoX )
      call  settextposition ( rows/12 - 1, cols - 30, curpos )
      call  outtext ( VarName )                             ! Variable
      call  settextposition ( rows/12 - 1, cols - 10, curpos )
      write (str_name, VarForm ) Var                        ! Variable value
      call  outtext ( str_name )

      call  settextposition ( rows/12    , cols - 30, curpos )
      call  outtext ( VarName2 )                            ! Variable
      call  settextposition ( rows/12    , cols - 10, curpos )
      write (str_name, VarForm ) Var2                       ! Variable value
      call  outtext ( str_name )
      if( Ikl .gt. 1 )  then
         I = Ikl
         goto 100
      endif
      dummy = setcolor  ( 3 )                   !?  ->
      dummy = rectangle ( $GFILLINTERIOR, -75,      33 + Y1/rows,
     +                                    X1/2-150, 35 )
      dummy = rectangle ( $GFILLINTERIOR, X1/2+115, 33 + Y1/rows,
     +                                    X1+10,    35 )
C -----------------------------------------------------------------------------
C           Draw X axe
C -----------------------------------------------------------------------------
      dummy = setcolor ( ICoAxe )
      call    moveto ( XAX-10,  2, xy )
      dummy = lineto ( XAX, 0)
      call    moveto ( XAX-10, -2, xy )
      dummy = lineto ( XAX, 0)
      call    moveto ( 0, 0, xy )
      dummy = lineto ( XAX-2, 0)
C -----------------------------------------------------------------------------
C           Draw Y axe
C -----------------------------------------------------------------------------
      call    moveto ( 2, YAX+10, xy )
      dummy = lineto ( 0, YAX)
      call    moveto (-2, YAX+10, xy )
      dummy = lineto ( 0, YAX)
      call    moveto ( 0, 0, xy )
      dummy = lineto ( 0, YAX+2)
C        dummy = setpixel ( X1,Y1 )
C -----------------------------------------------------------------------------
C           Found Max & Min for graph 1
C -----------------------------------------------------------------------------
      if( Ymax .eq. Ymin )  then                ! Found Max & Min
         call MinMaxN1 ( SY, Ymin,Ymax, Nmin,Nmax, N1,N2, NN1, Bananas )

         if( INum .eq. 2 ) then
            call MinMaxN1 ( SY, S, D, Nmin2,Nmax2, N12,N22,NN2, Ananas )
            Ymin = Min( Ymin, S )
            Ymax = Max( Ymax, D )
         endif
      endif

      if( INum .eq. 2 ) then                    !!!?  ->
         N12 = N1
         N22 = N2
      endif

      SY = Ymax - Ymin
C-----------------------------------------------------------------------------
C      call settextposition ( rows/12 + 1,     cols - 20, curpos )
C      write ( str_name, '(A5,E9.3)')  'Max =', YMax
C      call outtext ( str_name )                            ! Max output
C      call settextposition ( rows/12 + 2, cols - 20, curpos )
C      write ( str_name, '(A5,E9.3)')  'Min =', Ymin
C      call outtext ( str_name )                            ! Min output

      if ( SY .lt. 1.E-35 ) then
          SLow = Ymin                           ! Draw line = Ymin
          ILow = -Y2
          KR = 1
          ID = 0
          D  = 0.
      else
         dummy = Y2                             ! Divide and center Y
         call PROPOR( SY, Y1,dummy, Ymax,Ymin, SLow,ILow, ID,DY,D, KR )
      endif
C -----------------------------------------------------------------------------
C           Y axe
C -----------------------------------------------------------------------------
      IY = rows - 2
      S = SLow
      J = ILow
      do 20 I= 1,KR
         call    moveto ( -4, J, xy )           ! Draw Y sticks
         dummy = lineto (  0, J )
         J1 = IY - (( MaxRows * J )/ Y1)        ! Calculate text row number
         if( J1 .gt. IYnameRow + 1 ) then       ! Write Y sticks values
            call settextposition ( J1, 0, curpos )
            write ( str, Form )  S
            call outtext ( str )
         endif
         dummy = setcolor ( ICoX )
         if( S .eq. 0.) then
            call setlinestyle ( #0111 )         ! Grid 0 fat line 1
            dummy = setcolor  ( ICoAxe )
         else
            call setlinestyle ( #0101 )
         endif
         call    moveto (  0, J, xy )           ! Draw grid Y lines
         dummy = lineto ( X1, J )
         call setlinestyle ( #FFFF )
         dummy = setcolor ( ICoAxe )
         S = S + D
         J = J + ID
20       if( J .lt. YAX+5 ) exit
C -----------------------------------------------------------------------------
C           X axe
C -----------------------------------------------------------------------------
      L1 = Min0 ( N1, N12 )                     ! Found points interval
      L2 = Max0 ( N2, N22 )
      call settextposition ( rows-1, 7, curpos )   ! Write first point number
      write (str, '(I4)') L1
      call outtext ( str )

      IDX = (X1 - 15) / (L2 - L1)               ! X increment
      IXD = 0                                   ! X number type flag
      J   = 0
      J1  = 0

      IX1 = 0                                            ! X point coordinate
      IY1 = (( Bananas( N1 ) - Ymin ) * DY ) - Y2 - 1    ! Y point coordinate
      if( INum .eq. 2 ) IY12 = (( Ananas(N12) - Ymin ) * DY ) - Y2 - 1
                                                         ! Y point coordinate 2
      dummy = setcolor ( ICo1 )
      call    moveto ( 2, IY1, xy )             ! Draw Y1 stick
      dummy = lineto ( 0, IY1 )

      do 10 I= L1+1, L2

100      IX = ( I - L1 ) * IDX
         if( Ikl .eq. 1 )  goto 200
         if( I .gt. N12 .and. I .le. N22 .and. INum .eq. 2 )  then
            IY2 = (( Ananas( I ) - Ymin )* DY ) - Y2     ! Calculate coordinates 2
            dummy = setcolor( ICo2 )
            call    moveto ( IX1, IY12,  xy )            ! Draw graph 2
            dummy = lineto ( IX, IY2 )
            IY12 = IY2
         endif

         if( I .gt. N1  .and.  I .le. N2 )  then
            IY = (( Bananas( I ) - Ymin )* DY ) - Y2     ! Calculate coordinates 1
            dummy = setcolor ( ICo1 )
            call    moveto ( IX1, IY1, xy )              ! Draw graph 1
            dummy = lineto ( IX, IY )
            IY1 = IY
         endif

         IX1 = IX
         if( Ikl .ne. 0 )  goto 300             ! goto pause or return

200      IXD = IXD + IDX                        ! Calculate flag for numbers
         J1  = J1  + IDX
         if( IXD .ge. 10 )  then                ! Write point numbers
            dummy = setcolor ( ICoAxe )
            call    moveto ( IX, 4, xy )        ! Draw sticks axe X
            dummy = lineto ( IX, 0 )
            IXD = 0
            J   = J + 1
            if( J .ge. 4  .or.  J1 .ge. 35 ) then            ! Write point numbers
               I1 = ((70 * IX ) / X1) + 7.5     ! Calculate number text position
               if( I1 .lt. 68 ) then            ! Axe name can overide text
                  call settextposition ( rows-1, I1, curpos )
                  write (str_num, '(I4)') I
                  call outtext ( str_num )
               endif
               dummy = setcolor ( ICoX )
               call setlinestyle ( #0101 )      ! Grid X lines
               call moveto ( IX, 0, xy )
               dummy = lineto ( IX, Y1-15 )
               call setlinestyle ( #FFFF )
               J  = 0
               J1 = 0
           endif
        endif
10    continue

      dummy = settextcolor ( ICoAxe )
      call settextposition ( rows-1, cols-9, curpos )
      call outtext ( Xname )                                 ! X name
      dummy = settextcolor ( ICo1 )
      call settextposition ( IYnameRow, 0, curpos )          ! Y name
      call outtext ( Yname )
      if( INum .eq. 2 )  then
         dummy = settextcolor ( ICo2 )
         call settextposition ( IYnameRow, 12, curpos )      ! Write axe & graph names
         call outtext ( Yname2 )
      endif

300   if( Klp .ne. 0 )  then                    ! PAUSE message
         I = settextcolor ( 14 )
         call settextposition ( IWarnRow, 12, curpos )
         call outtext ( 'Pause - press any key' )
         I = Any_Key ()                         ! Wait for any key to be pressed
         call settextposition ( IWarnRow, 12, curpos )
         call outtext ( 'Wait a bit please... ' )
      endif

      return
      end
