C$LARGE
CĿ
C     Name: XPro2                                            03/30/93 00:33am 
C                                                                             
C     Description:                                                            
C                                                                             
C     Gregory Ivakhnenko (c),  1993.                                          
C

      Program  XPro2
      real     X  [allocatable] (:,:),
     +         YY [allocatable] (:,:),  Z   [allocatable] (:,:),
     +         XS [allocatable] (:),    XD  [allocatable] (:)
      real*8   XTX[allocatable] (:,:),  TXT [allocatable] (:,:),
     +         AL [allocatable] (:)
      integer        In_Card ( 3 ),  IM( 100 ),  IN( 300 ), NVar
      real           Par_Card( 1 ),  Var( 1 )
      character*12   Name_In, Name_Out       ! File name (for I/O)
      character*11   Name
      character*10   Form                    ! Input format

      common /LDAT/  JPR                     ! Print initial data flag
      common /LXPKL/ JXPRI
C      automatic I,J                          ! Put everything on stack by default
C=============================================================================
C       M(MM)    - ⢮ 쥪⮢
C       N(NN)    - ⢮ ਧ
C       X(MM,NN) -  쥪⮢,   ந  ⠭⮢
C       XS,XD      -  業஢  ନ஢
C       XTX,TXT,AL - tmp
C       YY(2,NN) - ,  ஬  ࠭ ஥樨 쥪⮢,
C                    뫠 ஥  ⠭⮢
C       Z(MM,2)  - , ਭ騩  ⠭⮢
C=============================================================================
                                          ! Parameters :
      NVar = 0                            ! Number of elements in parameter vector
C      Name_Out = 'OUT'                   ! Name of the file for results
C      write ( *,1111 )                   ! Write name board
C
C           Size  of  data  and  parameters  input
C
      call Card_In ( NVar, Name_In,Form, M,N, MM,NN, IM,IN,
     +               Par_Card,1,      In_Card,3, Var )       ! Card input
      JPr    = IN_Card( 1 )                ! initial data print flag
      JXPri  = IN_Card( 2 )                ! additional print flag
      JFile  = IN_Card( 3 )                ! results output to file flag

      write (*,'(/10X,A31,I2)') 'Initial data print flag   JPR =', JPR
      write (*, '(10X,A31,I2)') 'Data print flag         JXPri =', JXPri
      write (*, '(10X,A31,I2)') 'Output to file flag     JFile =', JFile
C
C           Memory allocation
C
      allocate ( X  ( MM,NN ),  XS ( MM ),     XD( MM ),
     +           XTX( MM,MM ),  TXT( MM,MM ),  AL( MM ),
     +           YY ( 2, NN ),  Z  ( MM,2 ),
     +           stat = MemErr )
      if( MemErr .ne. 0 )  stop 'Abort: Not enough storage!'
C
C           Initial array input
C
      call DatPIn ( Name_In, Form, M,N, MM,NN, X, IM,IN )
C
C
C
C      N = 10
C      call URACOX ( M,N, MM,NN, X )

      call XPKLx2 ( M,N, MM,NN, X,XS,XD,XTX,TXT,AL, YY,Z )
C
C           Output results to file
C
      Name     = Name_In
      Name_Out = Name // '!'
      if( JFile .ne. 0 ) then
         io = 2
         open( io,file= Name_Out,status='UNKNOWN',mode='WRITE',err=9999)
         write (io,222)  ( YY(1,I), I= 1,N )
         write (io,222)  ( YY(2,I), I= 1,N )
         write (io,'(/,9X,A20,3X,A12)') 'Data  file  name  -', Name_In
         write (io,'( 10X,A25,I3)')     'Number of variables   M =', M
         write (io,'( 10X,A25,I3)')     'Number of points      N =', N
         if( JPr .ne. 0 ) then
            write (io,'(/,5X,A)')  'Data array :'
            call MatPriF ( io, M,1, MM,NN, X )
         endif
      endif
C
C           Memory deallocation  and  end of the program
C
      deallocate ( X,XS,XD,XTX,TXT,AL, YY,Z, stat = IErr )
      if( IErr .ne. 0 )  write (*,*) 'Warning: Deallocation error!'
      stop ' '

111   format (/,10X,'Ortogonal projections :')
222   format (100F8.3)
9999  write(*,'(/,3A)') '* Error in the opening of file ',Name_Out,'!*'

C1111  format (/,' ',
C     +'ͻ',
C     +        /,' ',23X,'               MGDH  Algorithm',24X,'',
C     +        /,' ',17X,'Version 0.0   Gregory Ivakhnenko (c), 1993',
C     +                         18X,'',
C     +        /,' ',
C     +'ͼ',/)
      end
